<?php
// init world data master
function initWDataMst() {
  $wDataMst = array(
    "m_time" => -1,
    "m_raceTime" => 0 ,
    "m_sessionType" => -1,
    "m_track_number" => -1,
    "m_num_cars" => 0,
    "m_interval_count" => 0,
    "m_checkPointDistance" => 200,
    "m_bestLapTime" => LAPTIME_MAX,
    "m_bestLapTimeTID" => 99,
    "m_bestLapTimeDN" => "",
    "m_bestLapTimeDNS" => "",
    "m_bestLapTimeTC" => -1,
    "m_bestLapTimeL" => 0,
    "m_bestSector1Time" => LAPTIME_MAX,
    "m_bestSector1TimeTID" => 99,
    "m_bestSector1TimeDN" => "",
    "m_bestSector1TimeDNS" => "",
    "m_bestSector1TimeTC" => -1,
    "m_bestSector1TimeL" => 0,
    "m_bestSector2Time" => LAPTIME_MAX,
    "m_bestSector2TimeTID" => 99,
    "m_bestSector2TimeDN" => "",
    "m_bestSector2TimeDNS" => "",
    "m_bestSector2TimeTC" => -1,
    "m_bestSector2TimeL" => 0,
    "m_bestSector3Time" => LAPTIME_MAX,
    "m_bestSector3TimeTID" => 99,
    "m_bestSector3TimeDN" => "",
    "m_bestSector3TimeDNS" => "",
    "m_bestSector3TimeTC" => -1,
    "m_bestSector3TimeL" => 0,
    "m_fuelLeft" => 0,
    "m_fuelUse" => array( 0, 0, 0, 0 ),
    "m_fuelDistance" => array( 0, 0, 0, 0 ),
    "m_prevDistance" => 0,
    "m_debugInfo" => "",
  ) ;
  return $wDataMst ;
}

// init car data master
function initCDataMst( $idx, $wData, $cd1, &$wDataMst ) {
  global $TYRES ;

  $cdm1 = array(
    "m_lastLapTime" => LAPTIME_MAX,
    "m_bestLapTime" => LAPTIME_MAX,
    "m_currentLapNum" => 0,
    "m_sector" => 0,
    "m_penalties" => 0,
    "m_inPits" => 0,
    "m_inPitTime" => 0,
    "m_pitStops" => 0,
    "m_pitLaps" => 0,
    "m_driverName" => "",
    "m_driverNameShort" => "",
    "m_teamName" => "",
    "m_bestSector1Time" => LAPTIME_MAX,
    "m_bestSector2Time" => LAPTIME_MAX,
    "m_bestSector3Time" => LAPTIME_MAX,
    "m_bestSector1TimeSave" => LAPTIME_MAX,
    "m_bestSector2TimeSave" => LAPTIME_MAX,
    "m_bestSector3TimeSave" => LAPTIME_MAX,
    "m_carPositionHigh" => CARS_MAX,
    "m_carPositionLow" => 1,
    "m_lapTime" => array(),
    "m_sector1Time" => array(),
    "m_sector2Time" => array(),
    "m_sector3Time" => array(),
    "m_carPosition" => array(),
    "m_tyreCompound" => array(),
    "m_totalDistance" => 0,
    "m_checkPointCount" => 0,
    "m_checkPointTime" => array(),
    "m_currentLapInvalid" => array(),
    "m_interval" => 0,
    "m_speedTrapTime" => array(),
    "m_speedTrapDist" => array(),
    "m_speedTrapKPH" => 0,
    "m_prevLapDistance" => 0,
    "m_prevLapTime" => 0,
    "m_KPH" => 0,
    "m_lapDistance" => -1,
    "m_stopStartTime" => 0,
  ) ;

  $cln = $cd1["m_currentLapNum"] ;
  $cp  = $cd1["m_carPosition"] ;
  $blt = $cd1["m_bestLapTime"] ;
  $llt = $cd1["m_lastLapTime"] ;

  // set driver name and initial position
  setDriverName( $idx, $wData["m_player_car_index"], $wData["m_era"], NULL, $cd1, $cdm1 ) ;

  // set default data for race already started
  $cdm1["m_carPosition"][] = $cp ;
  if( $llt > 0 ) {
    for( $i=0 ; $i<($cln-1) ; $i++ ) {
      $cdm1["m_currentLapInvalid"][$i] = 0 ;
      $cdm1["m_sector1Time"][$i] = 0 ;
      $cdm1["m_sector2Time"][$i] = 0 ;
      $cdm1["m_sector3Time"][$i] = 0 ;
      $cdm1["m_lapTime"][$i] = 0 ;
      $cdm1["m_carPosition"][$i] = $cp ;
      $cdm1["m_tyreCompound"][$i] = -1 ;
    }
  }

  // set session best
  if( $blt > 0 && $blt < $wDataMst["m_bestLapTime"] ) {
    $key_blt = "m_bestLapTime" ;
    $wDataMst[$key_blt] = $blt ;
    $wDataMst[$key_blt . "TID"] = $cd1["m_teamId"] ;
    $wDataMst[$key_blt . "DN"] = $cdm1["m_driverName"] ;
    $wDataMst[$key_blt . "DNS"] = $cdm1["m_driverNameShort"] ;
    $wDataMst[$key_blt . "TC"] = sizeof( $TYRES ) - 1 ;
    $wDataMst[$key_blt . "L"] = 0 ;
  }

  return $cdm1 ;
}

function initIntervalData( $wData, $cData, $wDataMst, &$cDataMst ) {
  $rpos = makeRacePositionData( $wData, $cData ) ;
  $cpnum = CHECKPOINT_NUM ;
  $cpcsv = $cpnum ;
  $ts = $wData["m_track_size"] ;
  foreach( $rpos as $i => $v ) {
    $cd1 = $cData[$i] ;
    $cdm1 = &$cDataMst[$i] ;
    $cln = $cd1["m_currentLapNum"] ;
    $ld = $cd1["m_lapDistance"] ;
    $cpc = floor( ($ld / $wDataMst["m_checkPointDistance"]) + 
                  ($cpnum * ($cln-1) ) ) ;
//printf( "%d,%s,%d,%.2f\n", $v, $cdm1["m_driverNameShort"], $cln, $ld ) ;
    $chk = $ld / $ts ;

    if( $chk > 0.25 || $cpc > $cpcsv || $cpc < 0 ) {
      break ;
    }
    for( $j=1 ; $j<=$cpc ; $j++ ) {
      $cdm1["m_checkPointTime"][$j] = 0 ;
    }
    $cdm1["m_checkPointCount"] = $cpc ;
    $cpcsv = $cpc ;
  }

  return ;
}

/*
// get world data from D-BOX
function getWData( $ud ) {
  $wData = array(
    "m_time" => $ud["d01_1"],
    "m_totalDistance" => $ud["d01_4"],
    "m_drs" => $ud["d01_43"],
    "m_fuel_in_tank" => $ud["d01_46"],
    "m_fuel_capacity" => $ud["d01_47"],
    "m_brakes_temp" => array(
      $ud["d01_54"], $ud["d01_55"], $ud["d01_52"], $ud["d01_53"],
    ),
    "m_tyres_pressure" => array(
      $ud["d01_58"], $ud["d01_59"], $ud["d01_56"], $ud["d01_57"],
    ),
    "m_total_laps" => $ud["d01_61"],
    "m_track_size" => $ud["d01_62"],
    "m_sessionType" => $ud["d01_67"],
    "m_drsAllowed" => $ud["d01_68"],
    "m_track_number" => $ud["d01_69"],
    "m_vehicleFIAFlags" => $ud["d01_70"],
    "m_era" => $ud["d01_71"],
    "m_engine_temperature" => $ud["d01_72"],
    "m_tyres_temperature" => array(
      $ud["d02_3"], $ud["d02_4"], $ud["d02_1"], $ud["d02_2"],
    ),
    "m_tyres_wear" => array(
      $ud["d02_7"], $ud["d02_8"], $ud["d02_5"], $ud["d02_6"],
    ),
    "m_front_brake_bias" => $ud["d02_10"],
    "m_fuel_mix" => $ud["d02_11"],
    "m_tyres_damage" => array(
      $ud["d02_15"], $ud["d02_16"], $ud["d02_13"], $ud["d02_14"],
    ),
    "m_front_left_wing_damage" => $ud["d02_17"],
    "m_front_right_wing_damage" => $ud["d02_18"],
    "m_rear_wing_damage" => $ud["d02_19"],
    "m_engine_damage" => $ud["d02_20"],
    "m_gear_box_damage" => $ud["d02_21"],
    "m_exhaust_damage" => $ud["d02_22"],
    "m_pit_speed_limit" => $ud["d02_24"],
    "m_session_time_left" => $ud["d03_1"],
    "m_num_cars" => $ud["d04_4"],
    "m_player_car_index" => $ud["d04_5"],
  ) ;

  return $wData ;
}

// get cars data from D-BOX
function getCData( $ud, $m_num_cars ) {
  $cData = array() ;
  for( $i=0 ; $i<CARS_MAX ; $i++ ) {
    $key1 = sprintf("d%da_",$i+11 ) ;
    $key2 = sprintf("d%db_",$i+11 ) ;
    $cData[$i] = array(
      "m_lastLapTime" => $ud["${key1}4"],
      "m_currentLapTime" => $ud["${key1}5"],
      "m_bestLapTime" => $ud["${key1}6"],
      "m_sector1Time" => $ud["${key1}7"],
      "m_sector2Time" => $ud["${key1}8"],
      "m_lapDistance" => $ud["${key1}9"],
      "m_driverId" => $ud["${key2}1"],
      "m_teamId" => $ud["${key2}2"],
      "m_carPosition" => $ud["${key2}3"],
      "m_currentLapNum" => $ud["${key2}4"],
      "m_tyreCompound" => $ud["${key2}5"],
      "m_inPits" => $ud["${key2}6"],
      "m_sector" => $ud["${key2}7"],
      "m_currentLapInvalid" => $ud["${key2}8"],
      "m_penalties" => $ud["${key2}9"],
    ) ;
  }
  return $cData ;
}
*/

// reload config
function reloadConfig( $sdd, $wData, $cData, &$cDataMst ) {
//  include "relay.php" ;
  include "drivers_custom.php" ;
  for( $i=0 ; $i<CARS_MAX ; $i++ ) {
    $cd1 = $cData[$i] ;
    $cdm1 = &$cDataMst[$i] ;
    $sname = getArray( $sdd, $i, NULL ) ;
    setDriverName( $i, $wData["m_player_car_index"], $wData["m_era"], $sname, $cd1, $cdm1 ) ;
  }
}

// start session
function startSession( $wData, $cData, &$wDataMst, &$cDataMst ) {
  global $USE_DRIVERS_CUSTOM, $USE_CHANNEL, $PLAYER, $TRACKS, $SESSION_TYPE ;

  // initialize
  $nc = $wData["m_num_cars"] ;
  $cpnum = CHECKPOINT_NUM ;
  $wDataMst = initWDataMst() ;
  $wDataMst["m_time"] = $wData["m_time"] ;
  $wDataMst["m_track_number"] = $wData["m_track_number"] ;
  $wDataMst["m_num_cars"] = $nc ;
  $wDataMst["m_sessionType"] = $wData["m_sessionType"] ;
  $wDataMst["m_checkPointDistance"] = $wData["m_track_size"] / $cpnum ;
  $wDataMst["m_fuelLeft"] = $wData["m_fuel_in_tank"] ;

  $cDataMst = array() ;
  for( $i=0 ; $i<CARS_MAX ; $i++ ) {
    $cd1 = $cData[$i] ;
    $cDataMst[$i] = initCDataMst( $i, $wData, $cd1, $wDataMst ) ;
  }

  // initialize interval data
  initIntervalData( $wData, $cData, $wDataMst, $cDataMst ) ;
  // initialize sync status
  initSync() ;

  $msg[] = array(
    @sprintf( "Session start: %s / %s",
      $TRACKS[$wDataMst["m_track_number"]],
      $SESSION_TYPE[$wDataMst["m_sessionType"]] ), NMINDENT ) ;
  printMsg( $msg ) ;
}

// set driver name
function setDriverName( $i, $pci, $era, $sname, $cd1, &$cdm1 ) {
  global $DRIVERS, $DRIVERS_CUSTOM, $USE_DRIVERS_CUSTOM, $USE_CHANNEL, $PLAYER ;

  $idx = sprintf( "%04d%02d", $era, $cd1["m_driverId"] ) ;
  if( $i == $pci ) {
    // player
    $sz = sizeof( $PLAYER ) ;
    if( $sz == 2 && strlen($PLAYER[0]) > 0 ) {
      $cdm1["m_driverName"] = $PLAYER[0] ;
      $cdm1["m_driverNameShort"] = $PLAYER[1] ;
    } else {
      $cdm1["m_driverName"] = "Player" ;
      $cdm1["m_driverNameShort"] = "YOU" ;
    }
  } else {
    // others
    if( $USE_DRIVERS_CUSTOM == 1 ) {
      if( strlen($sname) == 3 ) {
        // custom driver from online
        $dmst = array( "", $sname ) ;
      } else {
        // custom driver
        $dmst = getArray( $DRIVERS_CUSTOM, $idx, array() ) ;
      }
    } else {
      // official drivers
      $dmst = getArray( $DRIVERS, $idx, array() ) ;
    }
    $cdm1["m_driverName"] = getArray( $dmst, 0, "Driver Unknown" ) ;
    $cdm1["m_driverNameShort"] = getArray( $dmst, 1, "ERR" ) ;
  }
}

// initialize sync status
function initSync() {
  global $SYNC_SEND_RESULT, $SYNC_SEND_NEXT, $SYNC_SEND_COUNT,
         $SYNC_GET_RESULT, $SYNC_GET_NEXT, $SYNC_GET_COUNT ;

  $SYNC_SEND_RESULT = FALSE ;
  $SYNC_SEND_NEXT = 0 ;
  $SYNC_SEND_COUNT = 0 ;
  $SYNC_GET_RESULT = FALSE ;
  $SYNC_GET_NEXT = 0 ;
  $SYNC_GET_COUNT = 0 ;
}

// send driver data to online
function sendDriverData( $wData, $cData ) {
  global $USE_DRIVERS_CUSTOM, $USE_CHANNEL, $PLAYER, $SYNC_SEND_RESULT, $SYNC_SEND_NEXT, $SYNC_SEND_COUNT ;

  // send driver data to online
  $rt = $wData["m_time"] ;
  $era = $wData["m_era"] ;
  if( $USE_DRIVERS_CUSTOM == 1 && $USE_CHANNEL > 0 && $era >= 1980 &&
      $SYNC_SEND_RESULT === FALSE && $rt >= $SYNC_SEND_NEXT &&
      ++$SYNC_SEND_COUNT <= SYNC_SEND_MAX ) {
    $pci = $wData["m_player_car_index"] ;
    $did = $cData[$pci]["m_driverId"] ;
    if( 0 <= $did && $did < 100 ) {
      $idx = sprintf( "%04d%02d", $era, $did ) ;

      $request =
        sprintf( "%s?ch=%d&idx=%d&name=%s", SYNC_LOCATION, $USE_CHANNEL, $idx, $PLAYER[1] ) ;
      $msg[] = array( sprintf("sending driver data to %s", $request), NMINDENT ) ;
      $result = @file_get_contents( $request ) ;
      if( strpos($result, ">" . $PLAYER[1] . "<") > 0 ) {
        $SYNC_SEND_RESULT = TRUE ;
        $msg[] = array( "success.", NMINDENT*2 ) ;
      } else {
        $msg[] = array( "failed.", NMINDENT*2 ) ;
        $SYNC_SEND_NEXT = $rt + SYNC_WAIT ;
      }
      printMsg( $msg ) ;
    }
  }
}

// sync driver data from online
function syncDriverData( $era, $wData, $cData, &$cDataMst ) {
  global $USE_DRIVERS_CUSTOM, $USE_CHANNEL, $SYNC_GET_RESULT, $SYNC_GET_NEXT, $SYNC_GET_COUNT, $DRIVERS ;

  $sdd = array() ;
  $pci = $wData["m_player_car_index"] ;
  $did = $cData[$pci]["m_driverId"] ;
  if( (0 <= $did && $did < 100 ) &&
      $USE_DRIVERS_CUSTOM && $USE_CHANNEL > 0 && $era >= 1980 &&
      $SYNC_GET_RESULT === FALSE && ++$SYNC_GET_COUNT <= SYNC_GET_MAX ) {
    // load from online
    $msg[] = array( sprintf("receiving driver data from %s", SYNC_DATA_CLIENT), NMINDENT ) ;
    $buf = @file_get_contents( SYNC_DATA_CLIENT ) ;
    if( $buf !== FALSE ) {
      $data = unserialize( $buf ) ;
      if( $data === FALSE ) {
        $data = array() ;
      }
      $ch_data = getArray( $data, $USE_CHANNEL, array() ) ;
      foreach( $ch_data as $idx => $name ) {
        foreach( $cData as $i => $cd1 ) {
          $idx2 = sprintf( "%04d%02d", $era, $cd1["m_driverId"] ) ;
          if( $idx == $idx2 ) {
            $sdd[$i] = $name ;
            $msg[] = array( @sprintf("%s -> %s", $DRIVERS[$idx2][1], $name), NMINDENT*2 ) ;
            break ;
          }
        }
      }
    }
    printMsg( $msg ) ;
  }

  return $sdd ;
}

// update status
function updateStatus( $shmid, $wData, $cData, &$wDataMst, &$cDataMst ) {
//$t = microtime(true) ;

  $rt = $wData["m_time"] ; // race time
  $st = $wData["m_sessionType"] ; // sessionType
  $nc = $wData["m_num_cars"] ;
  $ts = $wData["m_track_size"] ; // track size(length)
  $tn = $wData["m_track_number"] ; // track number
  $tln = $wData["m_total_laps"] ;
  $cpd = $wDataMst["m_checkPointDistance"] ; // track size / CHECKPOINT_NUM
  $pci = $wData["m_player_car_index"] ;
  $rdist = $tln * $ts ; // race distance
  $rpos = array() ;
  $fom = array() ;
  $wDataMst["m_time"] = $rt ;
//echo "$ts," . $cData[$pci]["m_lapDistance"] . "\n";

  // send driver data to online
  sendDriverData( $wData, $cData) ;

  // do each car
  for( $i=0 ; $i<CARS_MAX ; $i++ ) {
    $cd1 = $cData[$i] ; // 1 car data
    $cdm1 = &$cDataMst[$i] ; // 1 car data master
    $clt = $cd1["m_currentLapTime"] ;
    $cln = $cd1["m_currentLapNum"] ; // current lap 
    $ld = $cd1["m_lapDistance"] ; // current lap distance
    $dist = $ts * ($cln-1) + $ld ; // total distance

    // record invalid lap
    $key = "m_currentLapInvalid" ;
    $cdm1[$key][$cln-1] = $cd1[$key] ;

    // calc fuel data(player only)
    if( $i == $pci ) {
      if( $cd1["m_inPits"] == 0 ) {
        checkFuel( $st, $ld, $ts, $clt, $wData, $wDataMst ) ;
      }
    }

    // make interval data
    if( $st != 3 ||
        ($st == 3 && $clt > 0 && $dist <= ($rdist + $cpd * 2)) ) {
      // record time at the check point
      $cpc = floor( $dist / $cpd) ;
      if( $cpc > 0 ) {
        $dist_s = $cpc * $cpd ;
        $dist_e = $dist_s + 10 ;
        if( $dist_s <= $dist && $dist < $dist_e ) {
          $cdm1["m_checkPointTime"][$cpc] = $rt ;
          $cdm1["m_checkPointCount"] = $cpc ;
        }
      }
      // check pit
      checkPit( $st, $cln, $ld, $wData, $cd1, $wDataMst, $cdm1 ) ;
      // check speed trap
      checkSpeedTrap( $cln, $tn, $ts, $clt, $ld, $rt, $cd1, $cdm1 ) ;
      // record sector time
      $ret = recordSectorTime( $st, $cln, $cd1, $wDataMst, $cdm1 ) ;
      // restore session best
      if( $ret != 0 ) {
        restoreSessionBest( $wData, $wDataMst, $cDataMst ) ;
      }
    }
  }
//putDebugMsg( printf("[func()] %.3f\n", microtime(true)-$t ) ) ;

  // make race position data
  $rpos = makeRacePositionData( $wData, $cData ) ;
  // make track position data
  $tpos = makeTrackPositionData( $st, $ts, $rpos, $wData, $cData, $cDataMst ) ;
  // check interval
  checkInterval( $rpos, $wData, $cData, $cDataMst ) ;

  if( $cData[$pci]["m_currentLapTime"] > 0 ) {
    outputHtml( $shmid, $rpos, $tpos, $wData, $cData, $wDataMst, $cDataMst ) ;
  }
}

// make race position data
function makeRacePositionData( $wData, $cData ) {
  $rpos = array() ;
  for( $i=0 ;$i<CARS_MAX ; $i++ ) {
    $cp = $cData[$i]["m_carPosition"] ;
    if( $cp > 0 ) {
      $rpos[$i] = $cp ;
    }
  }
  asort( $rpos ) ;

  return $rpos ;
}

// make track position data
function makeTrackPositionData( $st, $ts, $rpos, $wData, $cData, &$cDataMst ) {
  // make array index=>lapDistance
  $tmp = array() ;
  $tpos = array() ;

  $lidx = 0 ;
  foreach( $rpos as $i => $v ) {
    $lidx = $i ;
     break ;
  }

  for( $i=0 ;$i<CARS_MAX ; $i++ ) {
    $cd1 = $cData[$i] ;
    $cdm1 = &$cDataMst[$i] ;
    $in_pits = ($cd1["m_inPits"] != 0) ;
    $cln = $cd1["m_currentLapNum"] ;
    $ld = $cd1["m_lapDistance"] ;
    $cp = $cd1["m_carPosition"] ;
    $dist = $ts * ($cln-1) + $ld ; // total distance
    if( $cp > 0 ) {
      if( isDriving($st, $wData, $cd1, $cdm1) ) {
        $tmp[$i] = $ld ;
      }
    }
  }
  // sort descending lapDistance
  arsort( $tmp ) ;
  $sz = sizeof( $tmp ) ;

  // make array from leader to bottom
  $out = FALSE ;
  foreach( $tmp as $i => $ld ) {
    if( $i == $lidx ) {
      $out = TRUE ;
    }
    if( $out ) {
      $tpos[$i] = $ld ;
    }
  }

  // add array until $CARS_MAX
  foreach( $tmp as $i=> $ld ) {
    if( sizeof($tpos) >= $sz ) {
      break ;
    } else {
      $tpos[$i] = $ld ;
    }
  }
  
  return $tpos ;
}
// check fuel data
function checkFuel( $st, $ld, $ts, $clt, $wData, &$wDataMst ) {
  $td = $wData["m_totalDistance"] ;
  $fit = $wData["m_fuel_in_tank"] ;
  $fm = $wData["m_fuel_mix"] ;
  $fl = &$wDataMst["m_fuelLeft"] ;
  $fu = &$wDataMst["m_fuelUse"] ;
  $futmp = 0 ;

  while( $td < 0 ) {
    $td += $ts ;
  }
  if( $clt > 0 ) {
    $futmp = ($fl - $fit) ;
  }

  $rd = $td - $wDataMst["m_prevDistance"] ;
  if( $rd > 0 && $rd < 50 && $futmp > 0 ) {
    $fu[$fm] += $futmp ;
    $wDataMst["m_fuelDistance"][$fm] += $rd ;
    $fl = $fit ;
    $wDataMst["m_prevDistance"] = $td ;
  }
  if( $rd > 50 || $rd < 0 ) {
    $fl = $fit ;
    $wDataMst["m_prevDistance"] = $td ;
  }
}

// check pit stops
function checkPit( $st, $cln, $ld, $wData, $cd1, &$wDataMst, &$cdm1 ) {
  $pit = $cd1["m_inPits"] ;
  $pitm = $cdm1["m_inPits"] ;

  // set inPits status and increment pit stops
  if( $pit != 0 ) {
    if( $pitm == 0 ) {
      $cdm1["m_inPitTime"] = $wData["m_time"] ;
      $cdm1["m_inPits"] = $pit ;
      $cdm1["m_pitStops"]++ ;
    }
  }
  // clear inPits status and record last stop laps
  if( $pit == 0 && $pitm != 0 ) {
    $cdm1["m_inPits"] = 0 ;
    $cdm1["m_pitLaps"] = $cd1["m_currentLapNum"] ;
    if( $st != 3 ) {
      // clear old sector time for practice and qualifying
      $cdm1["m_sector1Time"][$cln-1] = 0 ;
      $cdm1["m_sector2Time"][$cln-1] = 0 ;
      // clear fuel data for practice and qualifying
      $wDataMst["m_fuelLeft"] = $wData["m_fuel_in_tank"] ;
      $wDataMst["m_fuelUse"] = array( 0, 0, 0, 0 ) ;
      $wDataMst["m_fuelDistance"] = array( 0, 0, 0, 0 ) ;
      $wDataMst["m_prevDistance"] = $wData["m_totalDistance"] ;
    }
  }
}

// record sector time
function recordSectorTime( $st, $cln, $cd1, &$wDataMst, &$cdm1 ) {
  $ret = 0 ;
  $sn = $cd1["m_sector"] + 1 ;
  $cln1 = $cln - 1 ;
  $cln2 = $cln - 2 ;

  switch( $sn ) {
    case 2 :
      // sector 1
      $key = "m_sector1Time" ; 
      $key_best =  "m_bestSector1Time" ;
/*
if( strcmp($cdm1["m_driverNameShort"], "GRO") == 0 ) {
printf( "%8.5f\n", $cdm1[$key][$cln1] ) ;
die();
}
*/
      if( getArray($cdm1[$key], $cln1) == 0 ) {
        recordSectorTimeSub1( $cln, $key, $key_best, $cd1, $wDataMst, $cdm1 ) ;
      }
      break ;
    case 3 :
      // sector 2
      $key = "m_sector2Time" ; 
      $key_best =  "m_bestSector2Time" ;
      if( getArray($cdm1[$key], $cln1) == 0 ) {
        recordSectorTimeSub1( $cln, $key, $key_best, $cd1, $wDataMst, $cdm1 ) ;
      }
      break ;
    case 1 :
      // sector 3
      $key = "m_sector3Time" ; 
      $key_best =  "m_bestSector3Time" ;
      $clt = $cd1["m_currentLapTime"] ;
      if( $cln > 1 && $clt < 5 && getArray($cdm1[$key], $cln2) == 0 ) {
        $ret = recordSectorTimeSub3( $st, $cln, $key, $key_best, $cd1, $wDataMst, $cdm1 ) ;
      }
      break ;
  }
  return $ret ;
}

// record sector time for sector 1&2
function recordSectorTimeSub1( $cln, $key, $keyBest, $cd1, &$wDataMst, &$cdm1 ) {
  $t = $cd1[$key] ;
  $tm = &$cdm1[$key] ;

  if( $t > 0 ) {
/*
if(strcmp($cdm1["m_driverNameShort"],"NEK")==0){
echo "$cln,$t\n";
}
*/
    $tm[$cln-1] = $t ;
    $cli = getArray( $cdm1["m_currentLapInvalid"], $cln-1 ) ;
    if( $cli == 0 ) {
      // sector personal best
      if( $t < $cdm1[$keyBest] ) {
        $cdm1[$keyBest] = $t ;
      }
      // sector session best
      if( $t < $wDataMst[$keyBest] ) {
        $wDataMst[$keyBest] = $t ;
        $wDataMst[$keyBest . "TID"] = $cd1["m_teamId"] ;
        $wDataMst[$keyBest . "DN"] = $cdm1["m_driverName"] ;
        $wDataMst[$keyBest . "DNS"] = $cdm1["m_driverNameShort"] ;
        $wDataMst[$keyBest . "TC"] = $cd1["m_tyreCompound"] ;
        $wDataMst[$keyBest . "L"] = $cln ;
      }
    }
  }
}

// record sector time for sector 3
function recordSectorTimeSub3( $st, $cln, $key, $keyBest, $cd1, &$wDataMst, &$cdm1 ) {
  $ret = 0 ;
  $tm = &$cdm1[$key] ;
  $ld = $cd1["m_lapDistance"] ;
  $llt = $cd1["m_lastLapTime"] ;
  $clt = $cd1["m_currentLapTime"] ;
  if( 1 ) {
//  if( $cln > (sizeof($tm)+1) && $llt > 0 && $clt < 5 ) {
    $cln2 = $cln-2 ;

    // record data at control line
    $wDataMst["m_raceTime"] += $llt ;
    $cdm1["m_lapTime"][$cln2] = $llt ;
    $cdm1["m_carPosition"][$cln-1] = $cd1["m_carPosition"] ;
    $cdm1["m_tyreCompound"][$cln2] = $cd1["m_tyreCompound"] ;

    // record sector 3 time
    $s1t = getArray( $cdm1["m_sector1Time"], $cln2, SECTORTIME_MAX ) ;
    $s2t = getArray( $cdm1["m_sector2Time"], $cln2, SECTORTIME_MAX ) ;
    $s12t = $s1t + $s2t ;

    $s3t = LAPTIME_MAX ;
    if( $s1t > 0 && $s2t > 0 && $llt > $s12t ) {
      $s3t = $llt - $s12t ;
    }
    $tm[$cln2] = $s3t ;

    $cli2 = getArray( $cdm1["m_currentLapInvalid"], $cln2 ) ;
    if( $cli2 == 0 ) {
      // lap valid
      // sector personal best
      if( $s3t < $cdm1[$keyBest] ) {
        $cdm1[$keyBest] = $s3t ;
      }
      // sector session best
      if( $s3t < $wDataMst[$keyBest] ) {
        $wDataMst[$keyBest] = $s3t ;
        $wDataMst[$keyBest . "TID"] = $cd1["m_teamId"] ;
        $wDataMst[$keyBest . "DN"] = $cdm1["m_driverName"] ;
        $wDataMst[$keyBest . "DNS"] = $cdm1["m_driverNameShort"] ;
        $wDataMst[$keyBest . "TC"] = $cd1["m_tyreCompound"] ;
        $wDataMst[$keyBest . "L"] = $cln-1 ;
      }

      if( $llt > 0 ) {
        $key_blt = "m_bestLapTime" ;
        // lap personal best
        if( $llt < $cdm1[$key_blt] ) {
          $cdm1[$key_blt] = $llt ;
        }
        // lap session best
        if( $llt < $wDataMst[$key_blt] ) {
          $wDataMst[$key_blt] = $llt ;
          $wDataMst[$key_blt . "TID"] = $cd1["m_teamId"] ;
          $wDataMst[$key_blt . "DN"] = $cdm1["m_driverName"] ;
          $wDataMst[$key_blt . "DNS"] = $cdm1["m_driverNameShort"] ;
          $wDataMst[$key_blt . "TC"] = $cd1["m_tyreCompound"] ;
          $wDataMst[$key_blt . "L"] = $cln-1 ;
        }
      }
    } else {
      // lap invalid
      // restore valid personal best
      $cdm1["m_bestSector1Time"] = $cdm1["m_bestSector1TimeSave"] ;
      $cdm1["m_bestSector2Time"] = $cdm1["m_bestSector2TimeSave"] ;
      $cdm1["m_bestSector3Time"] = $cdm1["m_bestSector3TimeSave"] ;
      // restore valid session best
      $ret = 1 ;
    }
    // backup best time
    $cdm1["m_bestSector1TimeSave"] = $cdm1["m_bestSector1Time"] ;
    $cdm1["m_bestSector2TimeSave"] = $cdm1["m_bestSector2Time"] ;
    $cdm1["m_bestSector3TimeSave"] = $cdm1["m_bestSector3Time"] ;

/*
echo "L$cln-cdm1 " ;
print_r($cdm1) ;
*/
  }
  return $ret ;
}

// restore session best
function restoreSessionBest( $wData, &$wDataMst, $cDataMst ) {
  for( $i=1 ; $i<=3 ; $i++ ) {
    $time = array() ;
    $key = sprintf( "m_bestSector%dTime", $i ) ;
    for( $j=0 ; $j<$wData["m_num_cars"] ; $j++ ) {
      $time[] = $cDataMst[$j][$key] ;
    }
    sort( $time ) ;
    $wDataMst[$key] = $time[0] ;
  }
}

// check interval
function checkInterval( $rpos, $wData, $cData, &$cDataMst ) {
  $time = $wData["m_time"] ;
  $st = $wData["m_sessionType"] ;

  // get data for first position
  foreach( $rpos as $i => $v ) {
    $cdf = $cData[$i] ;
    $cdmf = $cDataMst[$i] ;
    break ;
  }

  switch( $st ) {
    case 1: // practice
    case 2: // qualifying
      // calculate interval against a leader
      $bltl = $cdf["m_bestLapTime"] ; 
      foreach( $rpos as $i => $v ) {
        $cdt = $cData[$i] ;
        $cdmt = &$cDataMst[$i] ;
        $bltt = $cdt["m_bestLapTime"] ; 
        if( $bltt != 0 && $bltt != LAPTIME_MAX ) {
          $cdmt["m_interval"] = $bltt - $bltl ;
        }
      }
      break ;
    case 3: // race
      // calculate interval for cars befor and after
      foreach( $rpos as $i => $v ) {
        $cdt = $cData[$i] ;
        $cdmt = &$cDataMst[$i] ;
        $cpc = $cdmt["m_checkPointCount"] ;
        if( $cpc > 0 ) {
          $bcpt_t = array_key_exists( "$cpc", $cdmt["m_checkPointTime"] ) ;
          $bcpt_f = array_key_exists( "$cpc", $cdmf["m_checkPointTime"] ) ;
          if( $bcpt_t && $bcpt_f && isDriving( $st, $wData, $cdt, $cdmt ) ) {
            $cptt = getArray( $cdmt["m_checkPointTime"], $cpc ) ;
            $cptf = getArray( $cdmf["m_checkPointTime"], $cpc ) ;
            $cdmt["m_interval"] = $cptt - $cptf ;
          } else {
            $cdmt["m_interval"] = 0 ;
          }
        }
        $cdmf = $cDataMst[$i] ;
      }
      break ;
  }
}

// check speed trap
function checkSpeedTrap( $cln, $tn, $ts, $clt, $ld, $rt, $cd1, &$cdm1 ) {
  global $SPDTRAP_DIST, $DEBUG_MODE ;
  $SPDTRAP_RANGE = 200 ;
  $SPDTRAP_CMAX = 400 ;

  // collect speed data
  $spdtd1 = $SPDTRAP_DIST[$tn] ;
  $spdtd2 = $spdtd1 - $SPDTRAP_RANGE ;
  $spdtd3 = $spdtd2 + $ts ;
  if( ($spdtd1 >= $ld && $ld >= $spdtd2) ||
      ($ts >= $ld && $ld >= $spdtd3) ) {
    if( sizeof($cdm1["m_speedTrapTime"]) < $SPDTRAP_CMAX ) {
      $cdm1["m_speedTrapTime"][] = $clt ;
      $cdm1["m_speedTrapDist"][] = $ld ;
    }
/*
if( DEBUG_ON && $DEBUG_MODE ) {
$debugbuf = sprintf( "[SpeedTrap] L%02d(%s): %7.3f - %8.3f\n",
  $cln, $cdm1["m_driverNameShort"], $clt, $ld ) ;
addDebugMsg( $debugbuf ) ;
putDebugMsg() ;
}
*/
  }

  // detect speed
  if( $spdtd1 < $ld && $ld < $spdtd1+50 && sizeof($cdm1["m_speedTrapTime"]) >= 3 ) {
    $kph = getKPH( $cln, $cdm1 ) ;
if( DEBUG_ON && $DEBUG_MODE ) {
$debugbuf = sprintf( "[getKPH()] L%02d(%s): %6.2f(%9.5f)\n",
  $cln, $cdm1["m_driverNameShort"], $kph, 0 ) ;
addDebugMsg( $debugbuf ) ;
putDebugMsg() ;
}
    if( $cdm1["m_speedTrapKPH"] < $kph ) {
      $cdm1["m_speedTrapKPH"] = $kph ;
    }
    $cdm1["m_speedTrapTime"] = array() ;
    $cdm1["m_speedTrapDist"] = array() ;
  }
}

// get KPH on speed trap
function getKPH( $cln, &$cdm1 ) {
  global $DEBUG_MODE ;
  $ACC_LIMIT = 99.800 ;

  $spdtkph = 0 ;
  $spdtacc = 0 ;
  $time = $cdm1["m_speedTrapTime"] ;
  $dist = $cdm1["m_speedTrapDist"] ;
  $kphr = array() ;
  $rcnt = 0 ;

  $tcnt = sizeof( $time ) ;
  $dcntmin = 999 ;
  $spdtkph = array() ;
  $spdtkpht = 0 ;
  $spdtkphc = 0 ;
  for( $i=1 ; $i<=5 ; $i++ ) {
    $tmp = getKPH1( $i, $time, $dist, $tcnt ) ;
    list( $kph, $dcnt ) = checkKPHAccuracy( $tmp, $cln, $cdm1 ) ;
    if( $kph > 0 ) {
      $spdtkph[] = $kph ;
      $spdtkpht += $kph ;
      $spdtkphc++ ;
    }
if( DEBUG_ON && $DEBUG_MODE ) {
$debugbuf = sprintf( "[checkKPHAccuracy(%d)] L%02d(%s): %6.2f(%2d)\n",
  $i, $cln, $cdm1["m_driverNameShort"], $kph, $dcnt ) ;
addDebugMsg( $debugbuf ) ;
}
  }

  if( sizeof($spdtkph) > 0 ) {
    $kph = $spdtkpht / $spdtkphc ;
  } else {
    $kph = 0 ;
  }
  return $kph ;
}

// get KPH lists at speed trap area
function getKPH1( $idx, $time, $dist, $cnt ) {
  $kphs = array() ;
  for( $i=0 ; $i<$cnt-$idx ; $i++ ) {
    $kph = calcKPH( $dist[$cnt-$idx], $dist[$i], $time[$cnt-$idx], $time[$i] ) ;
    if( $kph > 0 ) {
      $kphs[] = $kph ;
    }
  }
  return $kphs ;
}

// calc KPH with time and distance
function calcKPH( $d1, $d2, $t1, $t2 ) {
  $kph = 0 ;
  if( $d1 > $d2 && $d2 > 0 && $t1 > $t2 && $t2 > 0 ) {
    $kph = ($d1 - $d2) / ($t1 - $t2) * 3.6 ;
  }
  return ($kph>=KPHMAX) ? 0 : $kph ;
}

// check KPH data accuracy
function checkKPHAccuracy( $arr, $cln, $cdm1 ) {
  global $DEBUG_MODE ;

//  sort( $arr ) ;
  $cnt = sizeof($arr) ;
/*
if( DEBUG_ON && $DEBUG_MODE ) {
foreach( $arr as $v ) {
$debugbuf = sprintf( "[getKPH0()] L%02d(%s): %6.2f\n",
  $cln, $cdm1["m_driverNameShort"], $v ) ;
addDebugMsg( $debugbuf ) ;
}
}
*/
  $idx = floor( $cnt / 2 ) ;
  $spdtkph = 0 ;
  $dcntmax = 0 ;
  for($i=0 ; $i<$idx ; $i++ ) {
    $dcnt = 0 ;
    for($j=$i ; $j<$cnt-1 ; $j++ ) {
      $kph1 = $arr[$j] ;
      $kph2 = $arr[$j+1] ;
      $diff = ($kph2 / $kph1) - 1 ;
      $range = pow(( KPHMAX - $kph1 ) / 100, 2.5 ) / 100 ;
      $chk = $diff - $range ;
/*
if( DEBUG_ON && $DEBUG_MODE ) {
$mark = ($chk<=0) ? "@" : "x" ;
$debugbuf = sprintf( "[checkKPHAccuracy(%s)] %6.2f - %6.2f / %7.5f \n",
  $mark, $kph1, $kph2, $chk+1 ) ;
addDebugMsg( $debugbuf ) ;
}
*/

      if( $chk > 0 ) {
        $i = $j ;
        break ;
      }
      $dcnt++ ;
    }
    if( $dcnt >= 2 && $dcntmax < $dcnt ) {
      $spdtkph = $kph1 ;
      $dcntmax = $dcnt ;
    }    
    if( $j == $cnt-1 ) {
      $spdtkph = $kph2 ;
      break ;
    }
  }
  return array( $spdtkph, $dcntmax ) ;
}

// get sector time
function getSectorTime( $cdm1, $cln, $key ) {
  $idx = $cln - 1 ;
  if( $cln > 0 ) {
    $tm = getArray( $cdm1[$key], $idx ) ;
  } else {
    $tm = 0 ;
  }
  return $tm ;
}

// output formatted time
function outputTime( $time, $flag ) {
  if( is_numeric($time) ) {
    $tmp = $time ;
    $h = floor( $time / 3600 ) ;
    $tmp -= ($h * 3600) ;
    $m = floor( $tmp / 60 ) ;
    $tmp -= ($m * 60) ;
    $s = floor( $tmp ) ;
    $tmp -= $s ;
    $ms = floor( $tmp * 1000 ) ;

    if( $time > 0 && $time != LAPTIME_MAX ) {
      if( $time < 60 ) {
        $t = sprintf("%2d.%03d", $s, $ms ) ;
      } else {
        if( $time > 3600 ) {
          $t = sprintf("%d:%02d:%02d.%03d", $h, $m, $s, $ms ) ;
        } else {
          $t = sprintf("%d:%02d.%03d", $m, $s, $ms ) ;
        }
      }
      switch( $flag ) {
        case 1:
          printf("+%s", $t ) ;
          break ;
        default:
          printf("%s", $t ) ;
          break ;
      }
    }
  } else {
    printf("%s", $time) ;
  }
}

// check best time
function checkBestTime( $time, $key, $wDataMst, $cdm1 ) {
  $class = "none" ;
  if( $time != 0 ) {
    if( $time <= $cdm1[$key] ) {
      $class = "pb" ;
    }
    if( $time <= $wDataMst[$key] ) {
      $class = "sb" ;
    }
  }
  return $class ;
}

function isDriving( $st, $wData, $cd1, &$cdm1 ) {
  $rt = $wData["m_time"] ;
  $ld = $cd1["m_lapDistance"] ;
  $inpits = $cd1["m_inPits"] ;

  // check stop 
  $ld_diff = abs($ld - $cdm1["m_lapDistance"]) ;
  if( $cdm1["m_lapDistance"] < 0 || $ld_diff > IS_DRIVING_DIST ) {
    $cdm1["m_lapDistance"] = $ld ;
    $cdm1["m_stopStartTime"] = $rt ;
  }
  $stoptime = $rt - $cdm1["m_stopStartTime"] ;

  if( $st == 3 ) {
    // race
    if( $stoptime > STOP_LIMIT_TRACK ) {
      $ret = FALSE ;
    } else {
      $ret = TRUE ;
    }
  } else {
    // other
    if( ($inpits && $stoptime > STOP_LIMIT_PIT) ||
        (!$inpits && $stoptime > STOP_LIMIT_TRACK) ) {
      $ret = FALSE ;
    } else {
      $ret = TRUE ;
    }
  }

  return $ret ;
}
function getRaceTime( $laptimes ) {
  $ret = 0 ;
  foreach( $laptimes as $time ) {
    $ret += $time ;
  }
  return $ret ;
}

// speed indicator
function makeSpeedIndicator( $spd ) {
  $spd_min = 180 ;

  $res = 255 + 255 ;
  $p1 = $res / 2 ;
  $p2 = $res * 3 / 4 ;
  $p3 = $p2 - $res / 12 ;
  $unit = (KPHMAX - $spd_min + 1 ) / $res ;

  $uidx = ($spd - $spd_min) / $unit ;
  if( $p1 >= $uidx ) {
    $cr = 255 - $uidx ;
    $cg = 255 ;
    $cb = 255 ;
  }
  if( $p2 >= $uidx && $uidx > $p1 ) {
    $cr = ($uidx - $p1) * 2 ;
    $cg = 255 - (($uidx - $p1) / 3) ;
    $cb = 255 - (($uidx - $p1) * 2) ;
  }
  if( $uidx > $p2 ) {
    $cr = 255 ;
    $cg = 255 - ($uidx - $p3) ;
    $cb = 0 ;
  }

  return sprintf( "#%02x%02x%02x", $cr, $cg, $cb ) ;
}

function makeSpeedIndicatorSub( $spd, $spds, $spdx, $spdm, $unit, $cmax ) {
  $c = 255 ;
  if( $spd > $spds && $spd <= $spdx ) {
    $c = floor( ( $spd - $spds ) / $unit ) ;
    $c = ($c > $cmax) ? $cmax : $c ;
  }
  if( $spd > $spdx && $spd <= $spdm ) {
    $c = $cmax - floor( ( $spd - $spdx ) / $unit ) ;
    $c = ($c < 0 ) ? 0 : $c ;
  } 

  return $c ;
}

function getTyreStr( $idx, $default = "-" ) {
  global $TYRES ;

  return getArray( $TYRES, $idx, $default ) ;
}
?>
