<?php
include "config.php" ;
include "master.php" ;
include "relay.php" ;
include "drivers.php" ;
include "drivers_custom.php" ;
include "common.php" ;
include "functions.php" ;
include "output.php" ;

$resumefile = "" ;
$savefile = "" ;
$data_udp = TRUE ;
$isResume = FALSE ;
$flag_restart = FALSE ;
$flag_sw_best_kph = FALSE ;
$sync_count = 0 ;
$sdd = array() ;

$fpi = fopen( "php://stdin", "r" ) ;
if( $fpi === NULL ) {
  die() ;
}

// get parameter
$buf = fgets( $fpi, 4096 ) ;
$tmp = explode( "\n", $buf ) ;
list($data_udp, $resumefile) = explode( ',', $tmp[0] ) ;
$isResume = file_exists( $resumefile ) ;
/*
          $msg[] = array(
            @sprintf( "%d '%s'", $isResume, $resumefile), NMINDENT ) ;
          printMsg( $msg ) ;
*/

// init data
$wDataMst = initWDataMst() ;

// open shared memory
$shmid = shmop_open( SHM_KEY_H, 'c', 0644, SHM_SIZE_H ) ;
if( !$shmid ) {
  die() ;
} else {
  shmop_write( $shmid, "<!-- end -->", 0 ) ;
}

$fpo = NULL ;

// main loop
while( true ) {
  // sub loop
  for( $j=0 ; $j<300 ; $j++ ) {
    // recieve data
    $buf = fread( $fpi, PACKET_SIZE_T ) ;
    $sz = strlen($buf) ;

    // illegal packet
    if( $sz != PACKET_SIZE_T ) {
      continue ;
    }

    // commands
    if( isCommand($buf) ) {
      $cmd = substr( $buf, 0, PACKET_SIZE_C ) ;
      // bye with save
      if( strcmp($cmd, CMD_BYE_S) == 0 ) {
        if( strlen($savefile) > 0 ) {
          $arr = array(
            "wDataMst" => $wDataMst,
            "cDataMst" => $cDataMst,
          ) ;
          file_put_contents( $savefile, serialize($arr) ) ;
          echo "session data was saved to $savefile\n" ;
        }
        break 2 ;
      }
      // bye
      if( strcmp($cmd, CMD_BYE) == 0 ) {
        break 2 ;
      }
      // restart
      if( strcmp($cmd, CMD_RESTART) == 0 ) {
        $flag_restart = TRUE ;
        // flush telemetry data buffer
        if( $isSaveData && $fpo !== NULL ) {
          fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
          flush() ;
          fclose( $fpo ) ;
          $fpo = NULL ;
        }
        // init shared memory
        shmop_delete( $shmid ) ;
        $shmid = shmop_open( SHM_KEY_H, 'c', 0644, SHM_SIZE_H ) ;
      }
      // switch best / kph
      if( strcmp($cmd, CMD_SW_BEST_KPH) == 0 ) {
        if( $wDataMst["m_time"] > 0 ) {
          $SPDDISP_FLAG = 1 - $SPDDISP_FLAG ;
          $st = getArray( $wData, "m_sessionType", NULL ) ; // sessionType
          $ts = getArray( $wData, "m_track_size", NULL ) ; // track size(length)
          $rpos = makeRacePositionData( $wData, $cData ) ;
          $tpos = makeTrackPositionData( $st, $ts, $rpos, $wData, $cData, $cDataMst ) ;
          outputHtml( $shmid, $rpos, $tpos, $wData, $cData, $wDataMst, $cDataMst ) ;
        }
      }
      // resync driver data
      if( strcmp($cmd, CMD_RSY) == 0 ) {
        initSync() ;
      }
      continue ;
    }

    // unpack and extract
    $ud = unpack($UNPACK_FORMAT, $buf) ;
    $wData = getWData( $ud ) ;
    $cData = getCData( $ud, CARS_MAX ) ;
    $era = getArray( $wData,"m_era", 0 ) ;
    if( $era < 1980 ) {
      // discard garbage
      continue ;
    }

    // main function
    if( $wData["m_track_number"] != $wDataMst["m_track_number"]  ||
        $wData["m_sessionType"] != $wDataMst["m_sessionType"] ||
        $wData["m_time"] < $wDataMst["m_time"] ||
        $flag_restart
    ) {
      $flag_restart = FALSE ;
      // change track or change session or restart session
      if( $isResume ) {
        // resume session
        $isResume = FALSE ;
        $arr = unserialize( file_get_contents($resumefile) ) ;
        $wDataMst = getArray( $arr, "wDataMst" ) ;
        $cDataMst = getArray( $arr, "cDataMst" ) ;
        if( sizeof($cDataMst) == sizeof($cData) ) {
          $wDataMst["m_time"] = $wData["m_time"] ;

          $msg[] = array(
            @sprintf( "Session resume: %s / %s",
              $TRACKS[$wDataMst["m_track_number"]],
              $SESSION_TYPE[$wDataMst["m_sessionType"]] ) , NMINDENT ) ;
          printMsg( $msg ) ;
        } else {
          startSession( $wData, $cData, $wDataMst, $cDataMst ) ;
        }
      } else {
        // start session
        startSession( $wData, $cData, $wDataMst, $cDataMst ) ;
      }
      $sdd = array() ;
      $datestr = date("YmdHis") ;
      $track = $TRACKS[$wData["m_track_number"]] ;
      $st = $wData["m_sessionType"] ;
      $sid = substr( $SESSION_TYPE[$st], 0, 1 ) ;
      $savefile = sprintf( "data/%s_%s_%s.sav", $datestr, $track, $sid ) ;
      if( $data_udp && $isSaveData) {
        // flush telemetry data buffer
        if( $fpo !== NULL ) {
          fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
          flush() ;
          fclose( $fpo ) ;
          $fpo = NULL ;
        }
        $tlmfile = sprintf( "data/%s_%s_%s.dat", $datestr, $track, $sid ) ;
        $fpo = fopen( $tlmfile, "w" ) ;
        $wbuf = "" ;
      }
    }
    if( $wData["m_time"] >= $wDataMst["m_time"] ) {
      if( $data_udp && $isSaveData ) {
        $wbuf .= $buf ;
        if( strlen($wbuf) >= PACKET_SIZE_T * 300 ) {
          fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
          $wbuf = "" ;
        }
      }
      // update status
      updateStatus( $shmid, $wData, $cData, $wDataMst, $cDataMst ) ;
    }
  }

  // sync driver data from online
  $tmp = syncDriverData( $era, $wData, $cData, $cDataMst ) ;
  if( sizeof($tmp) > 0 ) {
    $sdd = $tmp ;
  }
  // reload config
  reloadConfig( $sdd, $wData, $cData, $cDataMst ) ;
}

if( $data_udp ) {
  // flush telemetry data buffer
  if( $isSaveData && $fpo !== NULL ) {
    fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
    flush() ;
    fclose( $fpo ) ;
    $fpo = NULL ;
  }
}

// close
shmop_delete( $shmid ) ;
shmop_close( $shmid ) ;

echo "\nbye\n" ;
fclose( $fpi ) ;
?>
